OGRE: Ogre::DefaultHardwareBufferManagerBase Class Reference - OGRE Documentation

Public Types | Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | Static Protected Attributes

# Ogre::DefaultHardwareBufferManagerBase Class Reference
[RenderSystem]

Specialisation of HardwareBufferManagerBase to emulate hardware buffers. More...

`#include <OgreDefaultHardwareBufferManager.h>`

Inheritance diagram for Ogre::DefaultHardwareBufferManagerBase:
[legend]

List of all members.

## Public Types
enum | BufferLicenseType { BLT_MANUAL_RELEASE, BLT_AUTOMATIC_RELEASE }
## Public Member Functions
| DefaultHardwareBufferManagerBase ()
| ~DefaultHardwareBufferManagerBase ()
HardwareVertexBufferSharedPtr | createVertexBuffer (size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
| Creates a vertex buffer.
HardwareIndexBufferSharedPtr | createIndexBuffer (HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
| Create a hardware vertex buffer.
RenderToVertexBufferSharedPtr | createRenderToVertexBuffer ()
| Create a hardware vertex buffer.
virtual VertexDeclaration * | createVertexDeclaration (void)
| Creates a new vertex declaration.
virtual void | destroyVertexDeclaration (VertexDeclaration *decl)
| Destroys a vertex declaration.
virtual VertexBufferBinding * | createVertexBufferBinding (void)
| Creates a new VertexBufferBinding.
virtual void | destroyVertexBufferBinding (VertexBufferBinding *binding)
| Destroys a VertexBufferBinding.
virtual void | registerVertexBufferSourceAndCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, const HardwareVertexBufferSharedPtr &copy)
| Registers a vertex buffer as a copy of another.
virtual HardwareVertexBufferSharedPtr | allocateVertexBufferCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, BufferLicenseType licenseType, HardwareBufferLicensee *licensee, bool copyData=false)
| Allocates a copy of a given vertex buffer.
virtual void | releaseVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Manually release a vertex buffer copy for others to subsequently use.
virtual void | touchVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Tell engine that the vertex buffer copy intent to reuse.
virtual void | _freeUnusedBufferCopies (void)
| Free all unused vertex buffer copies.
virtual void | _releaseBufferCopies (bool forceFreeUnused=false)
| Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.
virtual void | _forceReleaseBufferCopies (const HardwareVertexBufferSharedPtr &sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
virtual void | _forceReleaseBufferCopies (HardwareVertexBuffer *sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
void | _notifyVertexBufferDestroyed (HardwareVertexBuffer *buf)
| Notification that a hardware vertex buffer has been destroyed.
void | _notifyIndexBufferDestroyed (HardwareIndexBuffer *buf)
| Notification that a hardware index buffer has been destroyed.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Types
typedef set < HardwareVertexBuffer * > ::type | VertexBufferList
| WARNING: The following two members should place before all other members.
typedef set < HardwareIndexBuffer * > ::type | IndexBufferList
typedef set< VertexDeclaration * > ::type | VertexDeclarationList
typedef set < VertexBufferBinding * > ::type | VertexBufferBindingList
typedef multimap < HardwareVertexBuffer *, HardwareVertexBufferSharedPtr > ::type | FreeTemporaryVertexBufferMap
| Map from original buffer to temporary buffers.
typedef map < HardwareVertexBuffer *, VertexBufferLicense >::type | TemporaryVertexBufferLicenseMap
| Map from temporary buffer to details of a license.
## Protected Member Functions
virtual void | destroyAllDeclarations (void)
| Internal method for destroys all vertex declarations.
virtual void | destroyAllBindings (void)
| Internal method for destroys all vertex buffer bindings.
virtual VertexDeclaration * | createVertexDeclarationImpl (void)
| Internal method for creates a new vertex declaration, may be overridden by certain rendering APIs.
virtual void | destroyVertexDeclarationImpl (VertexDeclaration *decl)
| Internal method for destroys a vertex declaration, may be overridden by certain rendering APIs.
virtual VertexBufferBinding * | createVertexBufferBindingImpl (void)
| Internal method for creates a new VertexBufferBinding, may be overridden by certain rendering APIs.
virtual void | destroyVertexBufferBindingImpl (VertexBufferBinding *binding)
| Internal method for destroys a VertexBufferBinding, may be overridden by certain rendering APIs.
virtual HardwareVertexBufferSharedPtr | makeBufferCopy (const HardwareVertexBufferSharedPtr &source, HardwareBuffer::Usage usage, bool useShadowBuffer)
| Creates a new buffer as a copy of the source, does not copy data.
## Protected Attributes
VertexBufferList | mVertexBuffers
IndexBufferList | mIndexBuffers
VertexDeclarationList | mVertexDeclarations
VertexBufferBindingList | mVertexBufferBindings
FreeTemporaryVertexBufferMap | mFreeTempVertexBufferMap
| Map of current available temp buffers.
TemporaryVertexBufferLicenseMap | mTempVertexBufferLicenses
| Map of currently licensed temporary buffers.
size_t | mUnderUsedFrameCount
| Number of frames elapsed since temporary buffers utilization was above half the available.
## Static Protected Attributes
static const size_t | UNDER_USED_FRAME_THRESHOLD
| Number of frames to wait before free unused temporary buffers.
static const size_t | EXPIRED_DELAY_FRAME_THRESHOLD
| Frame delay for BLT_AUTOMATIC_RELEASE temporary buffers.

## Detailed Description

Specialisation of HardwareBufferManagerBase to emulate hardware buffers.

Remarks:
  You might want to instantiate this class if you want to utilise classes like MeshSerializer without having initialised the rendering system (which is required to create a 'real' hardware buffer manager.

Definition at line 103 of file OgreDefaultHardwareBufferManager.h.

## Member Typedef Documentation

typedef multimap<HardwareVertexBuffer*, HardwareVertexBufferSharedPtr>::type Ogre::HardwareBufferManagerBase::FreeTemporaryVertexBufferMap`[protected, inherited]`

Map from original buffer to temporary buffers.

Definition at line 187 of file OgreHardwareBufferManager.h.

typedef set<HardwareIndexBuffer*>::type Ogre::HardwareBufferManagerBase::IndexBufferList`[protected, inherited]`

Definition at line 120 of file OgreHardwareBufferManager.h.

typedef map<HardwareVertexBuffer*, VertexBufferLicense>::type Ogre::HardwareBufferManagerBase::TemporaryVertexBufferLicenseMap`[protected, inherited]`

Map from temporary buffer to details of a license.

Definition at line 191 of file OgreHardwareBufferManager.h.

typedef set<VertexBufferBinding*>::type Ogre::HardwareBufferManagerBase::VertexBufferBindingList`[protected, inherited]`

Definition at line 126 of file OgreHardwareBufferManager.h.

typedef set<HardwareVertexBuffer*>::type Ogre::HardwareBufferManagerBase::VertexBufferList`[protected, inherited]`

WARNING: The following two members should place before all other members.

Members destruct order is very important here, because destructing other members will cause notify back to this class, and then will access to this two members.

Definition at line 119 of file OgreHardwareBufferManager.h.

typedef set<VertexDeclaration*>::type Ogre::HardwareBufferManagerBase::VertexDeclarationList`[protected, inherited]`

Definition at line 125 of file OgreHardwareBufferManager.h.

## Member Enumeration Documentation

enum Ogre::HardwareBufferManagerBase::BufferLicenseType`[inherited]`

Enumerator:

  BLT_MANUAL_RELEASE | Licensee will only release buffer when it says so.
  BLT_AUTOMATIC_RELEASE | Licensee can have license revoked.

Definition at line 153 of file OgreHardwareBufferManager.h.

## Constructor & Destructor Documentation

Ogre::DefaultHardwareBufferManagerBase::DefaultHardwareBufferManagerBase | ( |  | ) |

Ogre::DefaultHardwareBufferManagerBase::~DefaultHardwareBufferManagerBase | ( |  | ) |

## Member Function Documentation

virtual void Ogre::HardwareBufferManagerBase::_forceReleaseBufferCopies | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer | ) | `[virtual, inherited]`

Internal method that forces the release of copies of a given buffer.

Remarks:
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters:

  | sourceBuffer | the source buffer as a shared pointer. Any buffer copies created from the source buffer are deleted.

Referenced by Ogre::HardwareBufferManager::_forceReleaseBufferCopies().

virtual void Ogre::HardwareBufferManagerBase::_forceReleaseBufferCopies | ( | HardwareVertexBuffer * | sourceBuffer | ) | `[virtual, inherited]`

Internal method that forces the release of copies of a given buffer.

Remarks:
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters:

  | sourceBuffer | the source buffer as a pointer. Any buffer copies created from the source buffer are deleted.

virtual void Ogre::HardwareBufferManagerBase::_freeUnusedBufferCopies | ( | void |  | ) | `[virtual, inherited]`

Free all unused vertex buffer copies.

Remarks:
  This method free all temporary vertex buffers that not in used. In normally, temporary vertex buffers are subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. But in some cases you want to free them to save hardware memory (e.g. application was runs in a long time, you might free temporary buffers periodically to avoid memory overload).

Referenced by Ogre::HardwareBufferManager::_freeUnusedBufferCopies().

void Ogre::HardwareBufferManagerBase::_notifyIndexBufferDestroyed | ( | HardwareIndexBuffer * | buf | ) | `[inherited]`

Notification that a hardware index buffer has been destroyed.

Referenced by Ogre::HardwareBufferManager::_notifyIndexBufferDestroyed().

void Ogre::HardwareBufferManagerBase::_notifyVertexBufferDestroyed | ( | HardwareVertexBuffer * | buf | ) | `[inherited]`

Notification that a hardware vertex buffer has been destroyed.

Referenced by Ogre::HardwareBufferManager::_notifyVertexBufferDestroyed().

virtual void Ogre::HardwareBufferManagerBase::_releaseBufferCopies | ( | bool | forceFreeUnused = `false` | ) | `[virtual, inherited]`

Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.

Parameters:

  | forceFreeUnused | If true, free all unused temporary buffers. If false, auto detect and free all unused temporary buffers based on temporary buffers utilization.

Referenced by Ogre::HardwareBufferManager::_releaseBufferCopies().

virtual HardwareVertexBufferSharedPtr Ogre::HardwareBufferManagerBase::allocateVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | BufferLicenseType | licenseType,
|  | HardwareBufferLicensee * | licensee,
|  | bool | copyData = `false` |
| ) |  |  | `[virtual, inherited]`

Allocates a copy of a given vertex buffer.

Remarks:
  This method allocates a temporary copy of an existing vertex buffer. This buffer is subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction.

Parameters:

  | sourceBuffer | The source buffer to use as a copy
  | licenseType | The type of license required on this buffer - automatic release causes this class to release licenses every frame so that they can be reallocated anew.
  | licensee | Pointer back to the class requesting the copy, which must implement HardwareBufferLicense in order to be notified when the license expires.
  | copyData | If true, the current data is copied as well as the structure of the buffer

Referenced by Ogre::HardwareBufferManager::allocateVertexBufferCopy().

HardwareIndexBufferSharedPtr Ogre::DefaultHardwareBufferManagerBase::createIndexBuffer | ( | HardwareIndexBuffer::IndexType | itype,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false` |
| ) |  |  | `[virtual]`

Create a hardware vertex buffer.

Implements Ogre::HardwareBufferManagerBase.

RenderToVertexBufferSharedPtr Ogre::DefaultHardwareBufferManagerBase::createRenderToVertexBuffer | ( |  | ) | `[virtual]`

Create a hardware vertex buffer.

Implements Ogre::HardwareBufferManagerBase.

HardwareVertexBufferSharedPtr Ogre::DefaultHardwareBufferManagerBase::createVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVerts,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false` |
| ) |  |  | `[virtual]`

Creates a vertex buffer.

Implements Ogre::HardwareBufferManagerBase.

virtual VertexBufferBinding* Ogre::HardwareBufferManagerBase::createVertexBufferBinding | ( | void |  | ) | `[virtual, inherited]`

Creates a new VertexBufferBinding.

Referenced by Ogre::HardwareBufferManager::createVertexBufferBinding().

virtual VertexBufferBinding* Ogre::HardwareBufferManagerBase::createVertexBufferBindingImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal method for creates a new VertexBufferBinding, may be overridden by certain rendering APIs.

virtual VertexDeclaration* Ogre::HardwareBufferManagerBase::createVertexDeclaration | ( | void |  | ) | `[virtual, inherited]`

Creates a new vertex declaration.

Referenced by Ogre::HardwareBufferManager::createVertexDeclaration().

virtual VertexDeclaration* Ogre::HardwareBufferManagerBase::createVertexDeclarationImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal method for creates a new vertex declaration, may be overridden by certain rendering APIs.

virtual void Ogre::HardwareBufferManagerBase::destroyAllBindings | ( | void |  | ) | `[protected, virtual, inherited]`

Internal method for destroys all vertex buffer bindings.

virtual void Ogre::HardwareBufferManagerBase::destroyAllDeclarations | ( | void |  | ) | `[protected, virtual, inherited]`

Internal method for destroys all vertex declarations.

virtual void Ogre::HardwareBufferManagerBase::destroyVertexBufferBinding | ( | VertexBufferBinding * | binding | ) | `[virtual, inherited]`

Destroys a VertexBufferBinding.

Referenced by Ogre::HardwareBufferManager::destroyVertexBufferBinding().

virtual void Ogre::HardwareBufferManagerBase::destroyVertexBufferBindingImpl | ( | VertexBufferBinding * | binding | ) | `[protected, virtual, inherited]`

Internal method for destroys a VertexBufferBinding, may be overridden by certain rendering APIs.

virtual void Ogre::HardwareBufferManagerBase::destroyVertexDeclaration | ( | VertexDeclaration * | decl | ) | `[virtual, inherited]`

Destroys a vertex declaration.

Referenced by Ogre::HardwareBufferManager::destroyVertexDeclaration().

virtual void Ogre::HardwareBufferManagerBase::destroyVertexDeclarationImpl | ( | VertexDeclaration * | decl | ) | `[protected, virtual, inherited]`

Internal method for destroys a vertex declaration, may be overridden by certain rendering APIs.

virtual HardwareVertexBufferSharedPtr Ogre::HardwareBufferManagerBase::makeBufferCopy | ( | const HardwareVertexBufferSharedPtr & | source,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer |
| ) |  |  | `[protected, virtual, inherited]`

Creates a new buffer as a copy of the source, does not copy data.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::HardwareBufferManagerBase::registerVertexBufferSourceAndCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | const HardwareVertexBufferSharedPtr & | copy |
| ) |  |  | `[virtual, inherited]`

Registers a vertex buffer as a copy of another.

Remarks:
  This is useful for registering an existing buffer as a temporary buffer which can be allocated just like a copy.

Referenced by Ogre::HardwareBufferManager::registerVertexBufferSourceAndCopy().

virtual void Ogre::HardwareBufferManagerBase::releaseVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) | `[virtual, inherited]`

Manually release a vertex buffer copy for others to subsequently use.

Remarks:
  Only required if the original call to allocateVertexBufferCopy included a licenseType of BLT_MANUAL_RELEASE.

Parameters:

  | bufferCopy | The buffer copy. The caller is expected to delete or at least no longer use this reference, since another user may well begin to modify the contents of the buffer.

Referenced by Ogre::HardwareBufferManager::releaseVertexBufferCopy().

virtual void Ogre::HardwareBufferManagerBase::touchVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) | `[virtual, inherited]`

Tell engine that the vertex buffer copy intent to reuse.

Remarks:
  Ogre internal keep an expired delay counter of BLT_AUTOMATIC_RELEASE buffers, when the counter count down to zero, it'll release for other purposes later. But you can use this function to reset the counter to the internal configured value, keep the buffer not get released for some frames.

Parameters:

  | bufferCopy | The buffer copy. The caller is expected to keep this buffer copy for use.

Referenced by Ogre::HardwareBufferManager::touchVertexBufferCopy().

## Member Data Documentation

const size_t Ogre::HardwareBufferManagerBase::EXPIRED_DELAY_FRAME_THRESHOLD`[static, protected, inherited]`

Frame delay for BLT_AUTOMATIC_RELEASE temporary buffers.

Definition at line 199 of file OgreHardwareBufferManager.h.

FreeTemporaryVertexBufferMap Ogre::HardwareBufferManagerBase::mFreeTempVertexBufferMap`[protected, inherited]`

Map of current available temp buffers.

Definition at line 189 of file OgreHardwareBufferManager.h.

IndexBufferList Ogre::HardwareBufferManagerBase::mIndexBuffers`[protected, inherited]`

Definition at line 122 of file OgreHardwareBufferManager.h.

TemporaryVertexBufferLicenseMap Ogre::HardwareBufferManagerBase::mTempVertexBufferLicenses`[protected, inherited]`

Map of currently licensed temporary buffers.

Definition at line 193 of file OgreHardwareBufferManager.h.

size_t Ogre::HardwareBufferManagerBase::mUnderUsedFrameCount`[protected, inherited]`

Number of frames elapsed since temporary buffers utilization was above half the available.

Definition at line 195 of file OgreHardwareBufferManager.h.

VertexBufferBindingList Ogre::HardwareBufferManagerBase::mVertexBufferBindings`[protected, inherited]`

Definition at line 128 of file OgreHardwareBufferManager.h.

VertexBufferList Ogre::HardwareBufferManagerBase::mVertexBuffers`[protected, inherited]`

Definition at line 121 of file OgreHardwareBufferManager.h.

VertexDeclarationList Ogre::HardwareBufferManagerBase::mVertexDeclarations`[protected, inherited]`

Definition at line 127 of file OgreHardwareBufferManager.h.

const size_t Ogre::HardwareBufferManagerBase::UNDER_USED_FRAME_THRESHOLD`[static, protected, inherited]`

Number of frames to wait before free unused temporary buffers.

Definition at line 197 of file OgreHardwareBufferManager.h.

The documentation for this class was generated from the following file:

- OgreDefaultHardwareBufferManager.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:54